function gameConnection::setHubPrint(%this)
{
	%this.HubPrint = "<just:center><font:palatino linotype:50>\c3" @ mfloor(%this.score) @ "\c6 " @ $Clicker_ScoreName;
	%this.HubPrint = %this.HubPrint @ "<br><just:left><font:palatino linotype:20>\c6Click Level: \c3" @ mfloor($Clicker_ScorePerClick_[%this.BL_ID]);
	%this.HubPrint = %this.HubPrint @ "\c6 - Microtick: \c3" @ mfloor($Clicker_Minitick);
	%this.HubPrint = %this.HubPrint @ "<just:right>\c6Type \c3/ViewUnits\c6 into chat to view your units.";
	
	// Printing
	commandToClient(%this, 'bottomPrint', %this.HubPrint, 0, true);
	
	return %this.HubPrint;
}

function serverCmdViewUnits(%client)
{
	if(%client.minigame == $DefaultMinigame)
	{
		messageClient(%client, '' , "\c6Your units:");
		messageClient(%client, '' , "\c6Blockheads: \c3" @ mfloor($Clicker_AutoBlockheads_[%client.BL_ID]) @ " <font:palatino linotype:16>\c2(" @ mfloor($Clicker_ScorePerClick_[%client.BL_ID]) @ " per click) \c4("@ mfloor($Clicker_AutoBlockheads_[%client.BL_ID] * $Clicker_ScorePerClick_[%client.BL_ID]) @ " total) \c3(every 25 microticks)");
		messageClient(%client, '' , "\c6Builders: \c3" @ mfloor($Clicker_AutoBuilders_[%client.BL_ID]) @ " <font:palatino linotype:16>\c2(" @ mfloor($Clicker_ScorePerClick_[%client.BL_ID]) @ " per click) \c4("@ mfloor($Clicker_AutoBuilders_[%client.BL_ID] * $Clicker_ScorePerClick_[%client.BL_ID]) @ " total) \c3(every 10 microticks)");
		messageClient(%client, '' , "\c6Eventers: \c3" @ mfloor($Clicker_AutoEventers_[%client.BL_ID]) @ " <font:palatino linotype:16>\c2(" @ mfloor($Clicker_ScorePerClick_[%client.BL_ID]) @ " per click) \c4("@ mfloor($Clicker_AutoEventers_[%client.BL_ID] * $Clicker_ScorePerClick_[%client.BL_ID]) @ " total) \c3(every 5 microticks)");
		messageClient(%client, '' , "\c6Autoclickers: \c3" @ mfloor($Clicker_AutoAutoclickers_[%client.BL_ID]) @ " <font:palatino linotype:16>\c2(" @ mfloor($Clicker_ScorePerClick_[%client.BL_ID]) @ " per click) \c4("@ mfloor($Clicker_AutoAutoclickers_[%client.BL_ID] * $Clicker_ScorePerClick_[%client.BL_ID]) @ " total) \c3(every 2 microticks)");
		messageClient(%client, '' , "\c6Spambots: \c3" @ mfloor($Clicker_AutoSpambots_[%client.BL_ID]) @ " <font:palatino linotype:16>\c2(" @ mfloor($Clicker_ScorePerClick_[%client.BL_ID] * 2) @ " per click) \c4("@ mfloor($Clicker_AutoSpambots_[%client.BL_ID] * $Clicker_ScorePerClick_[%client.BL_ID] * 2) @ " total) \c3(every microtick)");
	}
}

function GameConnection::addScore(%this, %add, %msg)
{
	if(%this.minigame == $DefaultMinigame)
	{
		%this.score += mfloor(%add);
		$Clicker_Score_[%this.BL_ID] = mfloor(%this.score);
	}
	if(%msg !$= "no msg")
	{
		commandToClient(%this,'centerPrint',"<just:right>\c3+" @ %add @ " \c6" @ $Clicker_ScoreName @ "(\c3" @ %msg @ "\c6)",1);
	}
	if(%this.score > 1999999999) //numbers over this could be risky and break blockland
	{
		%this.score = 1999999999;
		
		$Clicker_Score_[%this.BL_ID] = mfloor(%this.score);
	}
	if(mfloor($Clicker_ScorePerClick_[%this.BL_ID]) > 100)
	{
		$Clicker_ScorePerClick_[%this.BL_ID] = 100;
	}
	if(mfloor($Clicker_AutoBlockheads_[%this.BL_ID]) > 10000)
	{
		$Clicker_AutoBlockheads_[%this.BL_ID] = 10000;
	}
	if($Clicker_AutoBuilders_[%this.BL_ID] > 10000)
	{
		$Clicker_AutoBuilders_[%this.BL_ID] = 10000;
	}
	if($Clicker_AutoEventers_[%this.BL_ID] > 10000)
	{
		$Clicker_AutoEventers_[%this.BL_ID] = 10000;
	}
	if($Clicker_AutoAutoclickers_[%this.BL_ID] > 10000)
	{
		$Clicker_AutoAutoclickers_[%this.BL_ID] = 10000;
	}
	if($Clicker_AutoSpambots_[%this.BL_ID] > 10000)
	{
		$Clicker_AutoSpambots_[%this.BL_ID] = 10000;
	}
}

function GameConnection::subScore(%this, %sub, %msg)
{
	if(%this.minigame == $DefaultMinigame)
	{
		%this.score -= mfloor(%sub);
		$Clicker_Score_[%this.BL_ID] = mfloor(%this.score);
	}
	if(%msg !$= "no msg")
	{
		commandToClient(%this,'centerPrint',"<just:right>\c0-" @ %sub @ " \c6" @ $Clicker_ScoreName @ " (\c0" @ %msg @ "\c6)",1);
	}
}

function ClickerTick(%b)
{
	cancel($Clicker::Tick);
	%b += 1;
	if(%b > 100)
	{
		%b = 1;
		export("$Clicker_Score*", "config/server/BrickClicker/score.cs");
	}
	
	$Clicker_Minitick = %b;
	
	for(%a = 0; %a < $DefaultMinigame.numMembers; %a++)
	{
		%client = $DefaultMinigame.member[%a];
		if(isObject(%client))
		{
			%spc = mfloor($Clicker_ScorePerClick_[%client.BL_ID]);
			
			if(mfloor($Clicker_AutoBlockheads_[%client.BL_ID]) > 0)
			{
				%BKH = mfloor($Clicker_AutoBlockheads_[%client.BL_ID]);
				
				switch(%b)
				{
					case 25: %profit += mfloor(%BKH * %spc);
					case 50: %profit += mfloor(%BKH * %spc);
					case 75: %profit += mfloor(%BKH * %spc);
					case 100: %profit += mfloor(%BKH * %spc);
					default: 
				}
			}
			if(mfloor($Clicker_AutoBuilders_[%client.BL_ID]) > 0)
			{
				%BLD = mfloor($Clicker_AutoBuilders_[%client.BL_ID]);
				
				switch(%b)
				{
					case 10: %profit += mfloor(%BLD * %spc);
					case 20: %profit += mfloor(%BLD * %spc);
					case 30: %profit += mfloor(%BLD * %spc);
					case 40: %profit += mfloor(%BLD * %spc);
					case 50: %profit += mfloor(%BLD * %spc);
					case 60: %profit += mfloor(%BLD * %spc);
					case 70: %profit += mfloor(%BLD * %spc);
					case 80: %profit += mfloor(%BLD * %spc);
					case 90: %profit += mfloor(%BLD * %spc);
					case 100: %profit += mfloor(%BLD * %spc);
					default: 
				}
			}
			if(mfloor($Clicker_AutoEventers_[%client.BL_ID]) > 0)
			{
				%EVT = mfloor($Clicker_AutoEventers_[%client.BL_ID]);
				
				switch(%b)
				{
					case 5: %profit += mfloor(%EVT * %spc);
					case 10: %profit += mfloor(%EVT * %spc);
					case 15: %profit += mfloor(%EVT * %spc);
					case 20: %profit += mfloor(%EVT * %spc);
					case 25: %profit += mfloor(%EVT * %spc);
					case 30: %profit += mfloor(%EVT * %spc);
					case 35: %profit += mfloor(%EVT * %spc);
					case 40: %profit += mfloor(%EVT * %spc);
					case 45: %profit += mfloor(%EVT * %spc);
					case 50: %profit += mfloor(%EVT * %spc);
					case 55: %profit += mfloor(%EVT * %spc);
					case 60: %profit += mfloor(%EVT * %spc);
					case 65: %profit += mfloor(%EVT * %spc);
					case 70: %profit += mfloor(%EVT * %spc);
					case 75: %profit += mfloor(%EVT * %spc);
					case 80: %profit += mfloor(%EVT * %spc);
					case 85: %profit += mfloor(%EVT * %spc);
					case 90: %profit += mfloor(%EVT * %spc);
					case 95: %profit += mfloor(%EVT * %spc);
					case 100: %profit += mfloor(%EVT * %spc);
					default: 
				}
			}
			if(mfloor($Clicker_AutoAutoclickers_[%client.BL_ID]) > 0)
			{
				%ACL = mfloor($Clicker_AutoAutoclickers_[%client.BL_ID]);
				
				switch(%b)
				{
					case 2: %profit += mfloor(%ACL * %spc);
					case 4: %profit += mfloor(%ACL * %spc);
					case 6: %profit += mfloor(%ACL * %spc);
					case 8: %profit += mfloor(%ACL * %spc);
					case 10: %profit += mfloor(%ACL * %spc);
					case 12: %profit += mfloor(%ACL * %spc);
					case 14: %profit += mfloor(%ACL * %spc);
					case 16: %profit += mfloor(%ACL * %spc);
					case 18: %profit += mfloor(%ACL * %spc);
					case 20: %profit += mfloor(%ACL * %spc);
					case 22: %profit += mfloor(%ACL * %spc);
					case 24: %profit += mfloor(%ACL * %spc);
					case 26: %profit += mfloor(%ACL * %spc);
					case 28: %profit += mfloor(%ACL * %spc);
					case 30: %profit += mfloor(%ACL * %spc);
					case 32: %profit += mfloor(%ACL * %spc);
					case 34: %profit += mfloor(%ACL * %spc);
					case 36: %profit += mfloor(%ACL * %spc);
					case 38: %profit += mfloor(%ACL * %spc);
					case 40: %profit += mfloor(%ACL * %spc);
					case 42: %profit += mfloor(%ACL * %spc);
					case 44: %profit += mfloor(%ACL * %spc);
					case 46: %profit += mfloor(%ACL * %spc);
					case 48: %profit += mfloor(%ACL * %spc);
					case 40: %profit += mfloor(%ACL * %spc);
					case 52: %profit += mfloor(%ACL * %spc);
					case 54: %profit += mfloor(%ACL * %spc);
					case 56: %profit += mfloor(%ACL * %spc);
					case 58: %profit += mfloor(%ACL * %spc);
					case 60: %profit += mfloor(%ACL * %spc);
					case 62: %profit += mfloor(%ACL * %spc);
					case 64: %profit += mfloor(%ACL * %spc);
					case 66: %profit += mfloor(%ACL * %spc);
					case 68: %profit += mfloor(%ACL * %spc);
					case 70: %profit += mfloor(%ACL * %spc);
					case 72: %profit += mfloor(%ACL * %spc);
					case 74: %profit += mfloor(%ACL * %spc);
					case 76: %profit += mfloor(%ACL * %spc);
					case 78: %profit += mfloor(%ACL * %spc);
					case 80: %profit += mfloor(%ACL * %spc);
					case 82: %profit += mfloor(%ACL * %spc);
					case 84: %profit += mfloor(%ACL * %spc);
					case 86: %profit += mfloor(%ACL * %spc);
					case 88: %profit += mfloor(%ACL * %spc);
					case 90: %profit += mfloor(%ACL * %spc);
					case 92: %profit += mfloor(%ACL * %spc);
					case 94: %profit += mfloor(%ACL * %spc);
					case 96: %profit += mfloor(%ACL * %spc);
					case 98: %profit += mfloor(%ACL * %spc);
					case 100: %profit += mfloor(%ACL * %spc);
					default: 
				}
			}
			if(mfloor($Clicker_AutoSpambots_[%client.BL_ID]) > 0)
			{
				%SAB = mfloor($Clicker_AutoSpambots_[%client.BL_ID]);
				
				switch(%b)
				{
					case 1: %profit += mfloor(%SAB * (%spc * 2));
					default: %profit += mfloor(%SAB * (%spc * 2));
				}
			}
			if(mfloor(%profit) > 0)
			{
				%client.addScore(mfloor(%profit), "Total Unit Profit");
			}
			%client.setHubPrint();
		}
	}
	$Clicker::Tick = schedule(1500, 0, ClickerTick, %b);
}

function serverCmdClearGhostBricks(%client)
{
	if(!%client.isAdmin)
	{
		messageClient(%client, '' , "\c6You must be an \c3Admin\c6 to use this command.");
		return;
	}
	
	for (%i = 0; %i < ClientGroup.getCount(); %i++)
	{
		%clients = ClientGroup.getObject(%i);
		if(%clients.player.tempbrick)
			%clients.player.tempbrick.delete();
	}
}

function serverCmdTotalClicks(%client)
{
	messageClient(%client, '', "\c3" @ $Clicker_Score_ClickerBrick @ "\c6 clicks!");
}

//Server Voting by Dephurites
function servercmdnewVote(%client, %var1, %var2, %var3, %var4, %var5, %var6, %var7, %var8, %var9, %var10, %var11, %var12, %var13, %var14, %var15, %var16, %var17, %var18, %var19, %var20)
{
	if(10000 > %client.score)
	{
		messageClient(%client, '', "\c6You need \c310000\c6 " @ $Clicker_ScoreName @ " to make a new vote. You don't have enough.");
		return;
	}
	else
	{
		%client.subScore(10000, "Purchase");
		messageClient(%client, '', "\c6You paid \c310000\c6 " @ $Clicker_ScoreName @ " to make a new vote.");
	}
	
	for(%a = 1; %a < 21; %a++)
	{
		if(%var[%a] !$= "")
		{
			%vote = %vote SPC %var[%a];
		}
	}
	if(!$SV::isVote)
	{
		messageall('', "\c3" @ %client.name @ " \c6set up a new vote for \"\c3" @ %vote SPC "\c6\"! Type \c3/vote Yes \c3\c6or\c3 /vote No");
		$SV::Sch = schedule(30000, 0, "SV_End");
		$SV::isVote = 1;
	}
}

function servercmdvote(%client, %a)
{
	if(%client.hasvoted)
		return;

	if(%a $= "No")
	{
		warn(%client.name @ " voted No");
		%client.hasvoted = 1;
		$SV::Average--;
		messageAll('', "\c3" @ %client.name @ "\c6 voted No!");
	}
	else if(%a $= "Yes")
	{
		warn(%client.name @ " voted Yes");
		%client.hasvoted = 1;
		$SV::Average++;
		messageAll('', "\c3" @ %client.name @ "\c6 voted Yes!");
	}
}

function SV_End()
{
	if($SV::isVote)
	{
		cancel($SV::Sch);
		if($SV::Average == 0)
		{
			Messageall('', "\c6The vote was a \c3Tie\c6!");
		}
		else if($SV::Average < 0)
		{
			Messageall('', "\c6The greater vote was \c3no\c6, by \c3" @ $SV::Average - $SV::Average - $SV::Average @ " \c6person(s)!");
		}
		else if($SV::Average > 0)
		{
			Messageall('', "\c6The greater vote was \c3yes\c6, by \c3" @ $SV::Average @ " \c6person(s)!");
		}
		for(%a = 1; %a < ClientGroup.getcount(); %a++)
		{
			%client = ClientGroup.getObject(%a);
			%client.hasvoted = 0;
		}
		$SV::Average = 0;
		$SV::isVote = 0;
	}
}

function serverCmdGivePoints(%client, %amt, %name)
{
	%give = findclientbyname(%name);
	
	if(%give.name = %client.name)
		return;
	
	if(%amt $= "" || %amt <=0)
		%amt = 1;
		
	if(%amt >= 1000000000)
		%amt = 1000000000;
	
	if(%client.minigame == $DefaultMinigame && %give.minigame == $DefaultMinigame)
	{
		if(%client.score - %amt < 0)
		{
			messageClient(%client, '' , "\c6You don't have that many " @ $Clicker_ScoreName @ " to give.");
		}
		else if(%give.score + %amt > 1999999999)
		{
			messageClient(%client, '' , "\c6That would have maxed out their " @ $Clicker_ScoreName @ ". Try a lower number.");
		}
		else
		{
			%client.score -= %amt;
			%give.score += %amt;
			messageClient(%client, '' , "\c6You gave \c3" @ %amt @ "\c6 " @ $Clicker_ScoreName @ " to \c3" @ %give.name @ "\c6.");
			messageClient(%give, '' , "\c3" @ %client.name @ "\c6 gave you \c3" @ %amt @ "\c6 " @ $Clicker_ScoreName @ "!");
		}
	}
}

function serverCmdNamePoints(%client, %newname)
{
	if(!%client.isAdmin)
	{
		messageClient(%client, '' , "\c6You must be an \c3Admin\c6 to use this command.");
		return;
	}
	
	%oldname = $Clicker_ScoreName;
	$Clicker_ScoreName = %newname;
	
	Messageall('', "\c3" @ %oldname @ " \c6was renamed to \c3" @ %newname @ ".");
}