function serverCmdHelp(%client)
{
	messageClient(%client, '', "\c3Brick Clicker Help");
	messageClient(%client, '', "\c6The aim of the game is to click the large red brick at the spawn.");
	messageClient(%client, '', "\c6You get more " @ $Clicker_ScoreName @ " for clicking it. You can use your " @ $Clicker_ScoreName @ " to buy things.");
	messageClient(%client, '', "\c6  - \c3/Credits\c6 - See who contributed to this gamemode.");
	messageClient(%client, '', "\c6  - \c3/Shop\c6 - Check out what you could buy with your points.");
	if(%client.isSuperAdmin)
	{
		messageClient(%client, '', "\c6  - \c3/Admin\c6 - See what gamemode-specific tools you have as a super admin.");
		if($Clicker_Debug == true)
		{
			messageClient(%client, '', "\c6  - \c3/Debug\c6 - Check your developmental tools.");
		}
	}
	else if(%client.isAdmin)
	{
		messageClient(%client, '', "\c6  - \c3/Admin\c6 - See what gamemode-specific tools you have as an administrator.");
	}
	messageClient(%client, '', "\c6  - \c3/TotalClicks\c6 - See how many times the brick has been clicked!");
	messageClient(%client, '', "\c6  - \c3/ViewUnits\c6 - View your units!");
	messageClient(%client, '', "\c6  - \c3/GivePoints [amount] [player]\c6 - Give your hard earned " @ $Clicker_ScoreName @ " to other people.");
	messageClient(%client, '', "\c3Press Page Up and Page Down to scroll through the chat.");
}

function serverCmdCredits(%client)
{
	messageClient(%client, '', "\c3Main coders: \c6Crispy");
	messageClient(%client, '', "\c3Code sniplets: \c6Zapk, Iban");
	messageClient(%client, '', "\c3Hat shop core: \c6Zapk");
	messageClient(%client, '', "\c3Restricted Events: \c6Adam487");
	messageClient(%client, '', "\c3Server Voting: \c6Dephurites");
	messageClient(%client, '', "\c3Press Page Up and Page Down to scroll through the chat.");
}

function serverCmdShop(%client)
{
	messageClient(%client, '', "\c3Shop Commands");
	messageClient(%client, '', "\c6  - \c3/UpgradeClick [amount]\c6 - Earn more profit per click, for a price.");
	messageClient(%client, '', "\c6  - \c3/Unit\c6 - Buy some units that will click for you.");
	messageClient(%client, '', "\c6  - \c3/Title\c6 - Buy some sick titles.");
	messageClient(%client, '', "\c6  - \c3/Hat\c6 - Buy some classy hats.");
	messageClient(%client, '', "\c6  - \c3/NewVote [topic]\c6 - Ask some quirky questions! Supports up to 20 words.");
	messageClient(%client, '', "\c3Press Page Up and Page Down to scroll through the chat.");
}

function serverCmdAdmin(%client)
{
	if(!%client.isAdmin)
		return;
	messageClient(%client, '', "\c3Admin Commands");
	messageClient(%client, '', "\c6As an admin, you can use the restricted events and place clicker bricks. Please don't abuse this.");
	messageClient(%client, '', "\c6  - \c3/ClearGhostBricks \c6 - Clears ghost bricks.");
	messageClient(%client, '', "\c6  - \c3/NamePoints [name]\c6 - Names the score.");
	if(%client.isSuperAdmin)
	{
		messageClient(%client, '', "\c6  - \c3/Debug [on/off]\c6 - Toggle development tools.");
	}
}