function serverCmdUpgradeClick(%client, %amt)
{
	if(%client.minigame == $DefaultMinigame)
	{
		if(%amt $= "" || %amt <=0)
			%amt = 1;
		
		if(%amt >= 100)
			%amt = 100;
		
		if(mfloor($Clicker_ScorePerClick_[%client.BL_ID] + %amt) > 100)
		{
			messageClient(%client, '', "\c6That would max out your click level!");
			return;
		}
		
		%cost = mfloor((($Clicker_ScorePerClick_[%client.BL_ID] + %amt - 1) * 3) * 20);
		if(%cost > %client.score)
		{
			messageClient(%client, '', "\c6You need \c3" @ %cost @ "\c6 " @ $Clicker_ScoreName @ " to upgrade by " @ %amt @ ".");
		}
		else
		{
			%client.subScore(%cost, "Purchase");
			$Clicker_ScorePerClick_[%client.BL_ID] += %amt;
			messageClient(%client, '', "\c6You paid \c3" @ %cost @ "\c6 " @ $Clicker_ScoreName @ " so you can get \c3" @ mfloor($Clicker_ScorePerClick_[%client.BL_ID]) @ "\c6 " @ $Clicker_ScoreName @ " per click.");
		}
		
		%client.setHubPrint();
	}
	export("$Clicker_Score*", "config/server/BrickClicker/score.cs");
}

function serverCmdUnit(%client, %cmd, %unit, %amt)
{
	if(%cmd $= "")
	{
		messageClient(%client, '', "\c6Unit Index:");
		messageClient(%client, '', "\c3/Unit List \c6- \c3Display a list of available units and their prices.");
		messageClient(%client, '', "\c3/Unit Buy (unit) (amount) \c6- \c3Buy the desired units with " @ $Clicker_ScoreName @ ".");
		return;
	}
	if(%cmd $= "list")
	{
		messageClient(%client, '', "\c6Available Units:");
		messageClient(%client, '', "\c6 - Cost: \c3" @ mfloor(($Clicker_AutoBlockheads_[%client.BL_ID] + 1) * 15) @ " \c6- \c3Blockhead\c6 - You own \c3" @ $Clicker_AutoBlockheads_[%client.BL_ID] @ "\c6.");
		messageClient(%client, '', "\c6 - Cost: \c3" @ mfloor(($Clicker_AutoBuilders_[%client.BL_ID] + %amt) * 100) @ " \c6- \c3Blockhead\c6 - You own \c3" @ $Clicker_AutoBlockheads_[%client.BL_ID] @ "\c6.");
		messageClient(%client, '', "\c6 - Cost: \c3" @ mfloor(($Clicker_AutoEventers_[%client.BL_ID] + %amt) * 500) @ " \c6- \c3Blockhead\c6 - You own \c3" @ $Clicker_AutoBlockheads_[%client.BL_ID] @ "\c6.");
		messageClient(%client, '', "\c6 - Cost: \c3" @ mfloor(($Clicker_AutoAutoclickers_[%client.BL_ID] + %amt) * 3000) @ " \c6- \c3Blockhead\c6 - You own \c3" @ $Clicker_AutoBlockheads_[%client.BL_ID] @ "\c6.");
		messageClient(%client, '', "\c6 - Cost: \c3" @ mfloor(($Clicker_AutoSpambots_[%client.BL_ID] + %amt) * 10000) @ " \c6- \c3Blockhead\c6 - You own \c3" @ $Clicker_AutoBlockheads_[%client.BL_ID] @ "\c6.");
		return;
	}
	if(%cmd $= "buy")
	{
		if(%amt $= "" || %amt <=0)
			%amt = 1;
		
		if(%amt >= 10000)
			%amt = 10000;
		
		if(%unit $= "Blockhead")
		{
			if(mfloor($Clicker_AutoBlockheads_[%client.BL_ID] + %amt) > 10000)
			{
				messageClient(%client, '', "\c6That would max out your \c3Blockheads\c6! Try a lower number.");
				return;
			}
		
			%cost = mfloor(($Clicker_AutoBlockheads_[%client.BL_ID] + %amt) * 25);
			if(%cost > %client.score)
			{
				messageClient(%client, '', "\c6You need \c3" @ %cost @ "\c6 " @ $Clicker_ScoreName @ " to buy " @ %amt @ " \c3Blockheads\c6.");
			}
			else
			{
				%client.subScore(%cost, "Purchase");
				$Clicker_AutoBlockheads_[%client.BL_ID] += %amt;
				messageClient(%client, '', "\c6You paid \c3" @ %cost @ "\c6 " @ $Clicker_ScoreName @ " to buy " @ %amt @ " \c3Blockheads\c6.");
			}
			%client.setHubPrint();
			export("$Clicker_Auto*", "config/server/BrickClicker/auto.cs");
			return;
		}
		if(%unit $= "Builder")
		{
			if(mfloor($Clicker_AutoBuilders_[%client.BL_ID] + %amt) > 10000)
			{
				messageClient(%client, '', "\c6That would max out your \c3Builders\c6! Try a lower number.");
				return;
			}
		
			%cost = mfloor(($Clicker_AutoBuilders_[%client.BL_ID] + %amt) * 100);
			if(%cost > %client.score)
			{
				messageClient(%client, '', "\c6You need \c3" @ %cost @ "\c6 " @ $Clicker_ScoreName @ " to buy " @ %amt @ " \c3Builders\c6.");
			}
			else
			{
				%client.subScore(%cost, "Purchase");
				$Clicker_AutoBuilders_[%client.BL_ID] += %amt;
				messageClient(%client, '', "\c6You paid \c3" @ %cost @ "\c6 " @ $Clicker_ScoreName @ " to buy " @ %amt @ " \c3Builders\c6.");
			}
			%client.setHubPrint();
			export("$Clicker_Auto*", "config/server/BrickClicker/auto.cs");
			return;
		}
		if(%unit $= "Eventer")
		{
			if(mfloor($Clicker_AutoEventers_[%client.BL_ID] + %amt) > 10000)
			{
				messageClient(%client, '', "\c6That would max out your \c3Eventers\c6! Try a lower number.");
				return;
			}
		
			%cost = mfloor(($Clicker_AutoEventers_[%client.BL_ID] + %amt) * 500);
			if(%cost > %client.score)
			{
				messageClient(%client, '', "\c6You need \c3" @ %cost @ "\c6 " @ $Clicker_ScoreName @ " to buy " @ %amt @ " \c3Eventers\c6.");
			}
			else
			{
				%client.subScore(%cost, "Purchase");
				$Clicker_AutoEventers_[%client.BL_ID] += %amt;
				messageClient(%client, '', "\c6You paid \c3" @ %cost @ "\c6 " @ $Clicker_ScoreName @ " to buy " @ %amt @ " \c3Eventers\c6.");
			}
			%client.setHubPrint();
			export("$Clicker_Auto*", "config/server/BrickClicker/auto.cs");
			return;
		}
		if(%unit $= "Autoclicker")
		{
			if(mfloor($Clicker_AutoAutoclickers_[%client.BL_ID] + %amt) > 10000)
			{
				messageClient(%client, '', "\c6That would max out your \c3Autoclickers\c6! Try a lower number.");
				return;
			}
		
			%cost = mfloor(($Clicker_AutoAutoclickers_[%client.BL_ID] + %amt) * 3000);
			if(%cost > %client.score)
			{
				messageClient(%client, '', "\c6You need \c3" @ %cost @ "\c6 " @ $Clicker_ScoreName @ " to buy " @ %amt @ " \c3Autoclickers\c6.");
			}
			else
			{
				%client.subScore(%cost, "Purchase");
				$Clicker_AutoAutoclickers_[%client.BL_ID] += %amt;
				messageClient(%client, '', "\c6You paid \c3" @ %cost @ "\c6 " @ $Clicker_ScoreName @ " to buy " @ %amt @ " \c3Autoclickers\c6.");
			}
			%client.setHubPrint();
			export("$Clicker_Auto*", "config/server/BrickClicker/auto.cs");
			return;
		}
		if(%unit $= "Spambot")
		{
			if(mfloor($Clicker_AutoSpambots_[%client.BL_ID] + %amt) > 10000)
			{
				messageClient(%client, '', "\c6That would max out your \c3Spambots\c6! Try a lower number.");
				return;
			}
		
			%cost = mfloor(($Clicker_AutoSpambots_[%client.BL_ID] + %amt) * 10000);
			if(%cost > %client.score)
			{
				messageClient(%client, '', "\c6You need \c3" @ %cost @ "\c6 " @ $Clicker_ScoreName @ " to buy " @ %amt @ " \c3Spambots\c6.");
			}
			else
			{
				%client.subScore(%cost, "Purchase");
				$Clicker_AutoSpambots_[%client.BL_ID] += %amt;
				messageClient(%client, '', "\c6You paid \c3" @ %cost @ "\c6 " @ $Clicker_ScoreName @ " to buy " @ %amt @ " \c3Spambots\c6.");
			}
			%client.setHubPrint();
			export("$Clicker_Auto*", "config/server/BrickClicker/auto.cs");
			return;
		}
		//if they made it this far, the if statements caught nothing.
		messageClient(%client, '', "\c6That unit doesn't exist!");
		return;
	}
	messageClient(%client, '', "\c6Unknown unit command.");
}

function serverCmdHat(%client, %cmd, %hat)
{
	if(%cmd $= "")
	{
		messageClient(%client, '', "\c6Hat Index:");
		messageClient(%client, '', "\c3/hat list \c6- \c3Display a list of available hats and their prices.");
		messageClient(%client, '', "\c3/hat buy (hat) \c6- \c3Buy the desired hat with " @ $Clicker_ScoreName @ ".");
		messageClient(%client, '', "\c3/hat set (hat) \c6- \c3Set your current hat.");
		messageClient(%client, '', "\c3/hat remove \c6- \c3Remove your current hat.");
		return;
	}
	if(%cmd $= "list")
	{
		%hats[%hc = 0] = "Bandage";
		%hats[%hc++] = "Builder";
		%hats[%hc++] = "Cigar";
		%hats[%hc++] = "Swag";
		%hats[%hc++] = "Headphones";
		%hats[%hc++] = "Jason";
		%hats[%hc++] = "PaperBag";
		%hats[%hc++] = "Beret";
		%hats[%hc++] = "Shades";
		%hats[%hc++] = "Bandit";
		%hats[%hc++] = "Doctor";
		%hats[%hc++] = "Batman";
		%hats[%hc++] = "Dastardly";
		%hats[%hc++] = "Trucker";
		%hats[%hc++] = "Vet";
		%hats[%hc++] = "BigHead";
		%hats[%hc++] = "Cap";
		%hats[%hc++] = "Police";
		%hats[%hc++] = "Soda";
		%hats[%hc++] = "TopHat";
		messageClient(%client, '', "\c0Available Hats:");
		for(%a = 0; %a <= %hc; %a++)
		{
			%thishat = %hats[%a];
			messageClient(%client, '', "\c6 - Cost: \c3" @ getHatDatablock(%thishat).cost @ " \c6- \c3" @ %thishat @ ($Clicker_Shop_Hat_OwnedBy[%client.bl_id, %thishat] ? " \c6(Owned)" : ""));
		}
		return;
	}
	if(%cmd $= "buy")
	{
		if(!isHat(%hat))
		{
			messageClient(%client, '', "\c6That hat doesn't exist!");
			return;
		}
		%hat = getRealHatName(%hat);
		if($Clicker_Shop_Hat_OwnedBy[%client.bl_id, %hat])
		{
			messageClient(%client, '', "\c6You already own that hat!");
			return;
		}
		%db = getHatDatablock(%hat);
		if(%client.score < %db.cost)
		{
			messageClient(%client, '', "\c6You need \c3" @ %db.cost @ " \c6" @ $Clicker_ScoreName @ " to buy that hat!");
			return;
		}
		%client.score -= %db.cost;
		$Clicker_Score_[%client.BL_ID] = %client.score;
		$Clicker_Shop_Hat_OwnedBy[%client.bl_id, %hat] = true;
		messageAllExcept(%client, '', "\c3" @ %client.name @ " \c6has bought the \c3" @ %hat @ " \c6hat.");
		messageClient(%client, '', "\c6You have bought the \c3" @ %hat @ " \c6hat for \c3" @ %db.cost @ " \c6" @ $Clicker_ScoreName @ ". Equip it with \c3/hat set " @ %hat @ "\c6.");
		
		export("$Clicker_Score_*", "config/server/BrickClicker/score.cs");
		export("$Clicker_Shop_*", "config/server/BrickClicker/shop.cs");
		return;
	}
	if(%cmd $= "set")
	{
		if(!isHat(%hat))
		{
			messageClient(%client, '', "\c6That hat doesn't exist!");
			return;
		}
		%hat = getRealHatName(%hat);
		if(!$Clicker_Shop_Hat_OwnedBy[%client.bl_id, %hat])
		{
			messageClient(%client, '', "\c6You don't own that hat! Type \c3/hat buy " @ %hat @ " \c6to buy it.");
			return;
		}
		if($Clicker_Shop_Hat_CurrentHat[%client.bl_id] $= %hat)
		{
			messageClient(%client, '', "\c6That is already your current hat!");
			return;
		}
		$Clicker_Shop_Hat_CurrentHat[%client.bl_id] = %hat;
		messageClient(%client, '', "\c6You have set your current hat to \c3" @ %hat @ "\c6.");
		mountHat(%client);
		
		export("$Clicker_Shop_*", "config/server/BrickClicker/shop.cs");
		return;
	}
	if(%cmd $= "remove")
	{
		if($Clicker_Shop_Hat_CurrentHat[%client.bl_id] $= "")
		{
			messageClient(%client, '', "\c6You don't have a hat equipped!");
			return;
		}
		$Clicker_Shop_Hat_CurrentHat[%client.bl_id] = "";
		messageClient(%client, '', "\c6You have removed your hat.");
		mountHat(%client);
		
		export("$Clicker_Shop_*", "config/server/BrickClicker/shop.cs");
		return;
	}
	messageClient(%client, '', "\60Unknown hat command.");
}

function serverCmdTitle(%client, %cmd, %title)
{
	switch(%title)
	{
		case 1: %titlename = "KoolKid"; %cost = 5000; %realtitlename = "<color:66FF66>Kool Kid";
		case 2: %titlename = "Dastardly"; %cost = 100000; %realtitlename = "<color:AA3333>Dastardly";
		case 3: %titlename = "Fabulous"; %cost = 75000; %realtitlename = "<color:FF99FF>Fabulous";
		case 4: %titlename = "Crispy"; %cost = 100000; %realtitlename = "<color:661100>Crispy";
		case 5: %titlename = "MLG"; %cost = 50000; %realtitlename = "<color:336600>MLG";
		case 6: %titlename = "Sock"; %cost = 2500; %realtitlename = "<color:AAAAAA>Sock";
		case 7: %titlename = "Overpowered"; %cost = 100000; %realtitlename = "<color:ff0000>Overpowered";
		case 8: %titlename = "Deity"; %cost = 200000; %realtitlename = "<color:AAFFFF>Deity";
		case 9: %titlename = "TheAnswer"; %cost = 10000000; %realtitlename = "<color:FFFFAA>The Answer to Life, the Universe, and Everything";
		case 10: %titlename = "Dirt"; %cost = 1000; %realtitlename = "<color:996633>Dirt";
		case 11: %titlename = "Autoclicker"; %cost = 50000; %realtitlename = "<color:FFFFAA>Autoclicker";
		case 12: %titlename = "Underscore"; %cost = 50; %realtitlename = "<color:100100>_";
		case 13: %titlename = "Master"; %cost = 1900000000; %realtitlename = "<color:00FF00>Brick Clicker Master";
		case 14: %titlename = "BetaTester"; %cost = 1000000; %realtitlename = "<color:6666FF>Blockland 2 Beta Tester";
		case 15: %titlename = "SuperKoolKid"; %cost = 100000; %realtitlename = "<color:FFFFAA>Super Kool Kid";
		case 16: %titlename = "PCMaster"; %cost = 500000; %realtitlename = "<color:100100>PC Master Race";
		case 17: %titlename = "PornStar"; %cost = 100000; %realtitlename = "<color:FF99FF>Porn Star";
		default: %title = 0;
	}
	if(%cmd $= "")
	{
		messageClient(%client, '', "\c6Title Index:");
		messageClient(%client, '', "\c3/title list \c6- \c3Display a list of available titles and their prices.");
		messageClient(%client, '', "\c3/title buy (number) \c6- \c3Buy the desired title with " @ $Clicker_ScoreName @ ".");
		messageClient(%client, '', "\c3/title set (number) \c6- \c3Set your current title.");
		messageClient(%client, '', "\c3/title remove \c6- \c3Remove your current title.");
		return;
	}
	if(%cmd $= "list")
	{
		messageClient(%client, '', "\c6Available Titles:");
		messageClient(%client, '', "\c21\c6 - Cost: \c35000 \c6- <color:66FF66>Kool Kid");
		messageClient(%client, '', "\c22\c6 - Cost: \c3100000 \c6- <color:AA3333>Dastardly");
		messageClient(%client, '', "\c23\c6 - Cost: \c375000 \c6- <color:FF99FF>Fabulous");
		messageClient(%client, '', "\c24\c6 - Cost: \c3100000 \c6- <color:661100>Crispy");
		messageClient(%client, '', "\c25\c6 - Cost: \c350000 \c6- <color:336600>MLG");
		messageClient(%client, '', "\c26\c6 - Cost: \c32500 \c6- <color:AAAAAA>Sock");
		messageClient(%client, '', "\c27\c6 - Cost: \c3100000 \c6- <color:ff0000>Overpowered");
		messageClient(%client, '', "\c28\c6 - Cost: \c3200000 \c6- <color:AAFFFF>Deity");
		messageClient(%client, '', "\c29\c6 - Cost: \c310000000 \c6- <color:FFFFAA>The Answer to Life, the Universe, and Everything");
		messageClient(%client, '', "\c210\c6 - Cost: \c31000 \c6- <color:996633>Dirt");
		messageClient(%client, '', "\c211\c6 - Cost: \c350000 \c6- <color:FFFFAA>Autoclicker");
		messageClient(%client, '', "\c212\c6 - Cost: \c350 \c6- <color:666666>_");
		messageClient(%client, '', "\c213\c6 - Cost: \c31900000000 \c6- <color:00FF00>Brick Clicker Master");
		messageClient(%client, '', "\c214\c6 - Cost: \c31000000 \c6- <color:6666FF>Blockland 2 Beta Tester");
		messageClient(%client, '', "\c215\c6 - Cost: \c3100000 \c6- <color:FFFFAA>Super Kool Kid");
		messageClient(%client, '', "\c216\c6 - Cost: \c3500000 \c6- <color:100100>PC Master Race");
		messageClient(%client, '', "\c217\c6 - Cost: \c3100000 \c6- <color:FF99FF>Porn Star");
		return;
	}
	if(%cmd $= "buy")
	{
		if(%title == 0)
		{
			messageClient(%client, '', "\c6That title doesn't exist! Use the number to select the title.");
			return;
		}
		if($Clicker_Shop_Title_OwnedBy[%client.bl_id, %titlename])
		{
			messageClient(%client, '', "\c6You already own that title!");
			return;
		}
		if(%cost $= "")
		{
			%cost = 100000;
			messageClient(%client, '', "\c6That title doesn't have a set price! Setting it to \c3" @ %cost @ " \c6" @ $Clicker_ScoreName @ " by default...");
			return;
		}
		if(%client.score < %cost)
		{
			messageClient(%client, '', "\c6You need \c3" @ %cost @ " \c6" @ $Clicker_ScoreName @ " to buy that title!");
			return;
		}
		%client.score -= %cost;
		$Clicker_Score_[%client.BL_ID] = %client.score;
		$Clicker_Shop_Title_OwnedBy[%client.bl_id, %titlename] = true;
		messageAllExcept(%client, '', "\c3" @ %client.name @ " \c6has bought the \c3" @ %realtitlename @ " \c6title.");
		messageClient(%client, '', "\c6You have bought the \c3" @ %realtitlename @ " \c6title for \c3" @ %cost @ " \c6" @ $Clicker_ScoreName @ ". Equip it with \c3/title set " @ %title @ "\c6.");
		
		export("$Clicker_PlayerScore_*", "config/server/BrickClicker/score.cs");
		export("$Clicker_Shop_*", "config/server/BrickClicker/shop.cs");
		return;
	}
	if(%cmd $= "set")
	{
		if(%title == 0)
		{
			messageClient(%client, '', "\c6That title doesn't exist! Use the number to select the title.");
			return;
		}
		if(!$Clicker_Shop_Title_OwnedBy[%client.bl_id, %titlename])
		{
			messageClient(%client, '', "\c6You don't own that title! Type \c3/title buy " @ %title @ " \c6to buy it.");
			return;
		}
		if($Clicker_Shop_Title_CurrentTitle[%client.bl_id] $= %realtitlename)
		{
			messageClient(%client, '', "\c6That is already your current title!");
			return;
		}
		$Clicker_Shop_Title_CurrentTitle[%client.bl_id] = %realtitlename;
		messageClient(%client, '', "\c6You have set your current title to " @ %realtitlename @ "\c6.");
		
		export("$Clicker_Shop_*", "config/server/BrickClicker/shop.cs");
		return;
	}
	if(%cmd $= "remove")
	{
		if($Clicker_Shop_Title_CurrentTitle[%client.bl_id] $= "")
		{
			messageClient(%client, '', "\c6You do not have a title equipped!");
			return;
		}
		$Clicker_Shop_Title_CurrentTitle[%client.bl_id] = "";
		messageClient(%client, '', "\c6You have removed your title.");
		
		export("$Clicker_Shop_*", "config/server/BrickClicker/shop.cs");
		return;
	}
	messageClient(%client, '', "\c6Unknown title command.");
}