echo("\c4Loading scripts.");

exec("Add-Ons/Gamemode_Brick_Clicker/code/AdminEvents.cs");
exec("Add-Ons/Gamemode_Brick_Clicker/code/bricks.cs");
exec("Add-Ons/Gamemode_Brick_Clicker/code/hats.cs");
exec("Add-Ons/Gamemode_Brick_Clicker/code/main.cs");
exec("Add-Ons/Gamemode_Brick_Clicker/code/shop.cs");
exec("Add-Ons/Gamemode_Brick_Clicker/code/help.cs");
exec("Add-Ons/Gamemode_Brick_Clicker/code/package.cs");

echo("\c4All scripts loaded.");

if(isFile("config/server/BrickClicker/score.cs"))
	exec("config/server/BrickClicker/score.cs");

if(isFile("config/server/BrickClicker/auto.cs"))
	exec("config/server/BrickClicker/auto.cs");

if(isFile("config/server/BrickClicker/shop.cs"))
	exec("config/server/BrickClicker/shop.cs");

function startTick()
{
	$Clicker::Tick = schedule(10000, 0, ClickerTick);
}
startTick();

if($Clicker_ScoreName $= "")
	$Clicker_ScoreName = "Points";

function serverCmdExec(%client)
{
	if($Clicker_Debug == false)
		return;
	if(%client.isSuperAdmin)
	{
		setModPaths(getModPaths());
		exec("Add-Ons/Gamemode_Brick_Clicker/server.cs");
		messageAll('', "\c3Executing server.cs. The server may crash or screw up!");
		messageClient(%client, '' , "\c3You executed server.cs!");
	}
}

function serverCmdTransmitDatablocks(%client)
{
	if($Clicker_Debug == false)
		return;
	if(%client.isSuperAdmin)
	{
		transmitdatablocks(1);
		messageClient(%client, '' , "\c3You transmitted the datablocks!");
	}
}

if(!$Clicker::Initialized)
{
	$Clicker_Debug = false;
	// Restricted Events
	registerAdminOnlyOutputEvent("fxDTSBrick","RadiusImpulse",1);

	registerAdminOnlyOutputEvent("GameConnection","bottomPrint",1);
	registerAdminOnlyOutputEvent("GameConnection","centerPrint",1);
	registerAdminOnlyOutputEvent("GameConnection","IncScore",1);

	registerAdminOnlyOutputEvent("MiniGame","BottomPrintAll",1);
	registerAdminOnlyOutputEvent("MiniGame","CenterPrintAll",1);
	registerAdminOnlyOutputEvent("MiniGame","ChatMsgAll",1);
	registerAdminOnlyOutputEvent("MiniGame","Reset",1);
	registerAdminOnlyOutputEvent("MiniGame","RespawnAll",1);
}

function serverCmdDebug(%client, %set)
{
	if(!%client.isSuperAdmin)
		return;
	
	if(%set $= "on")
	{
		Messageall('', "\c3DEBUG HAS BEEN TURNED ON.");
		$Clicker_Debug = true;
		return;
	}
	
	if(%set $= "off")
	{
		Messageall('', "\c6Debug has been turned off.");
		$Clicker_Debug = false;
		return;
	}
	
	messageClient(%client, '', "\c3Debug Commands");
	messageClient(%client, '', "\c6  - \c3/Exec\c6 - Execute server.cs.");
	messageClient(%client, '', "\c6  - \c3/TransmitDatablocks\c6 - Transmits the datablocks. Everyone should reconnect after doing this.");
}

$Clicker::Initialized = true;